   --      
   --  ,    
   -- [,,,,1991,.131]
   ------------------------------------------------
   import LibGrp_2
   ------------------------------------------------------
   --        
   --   ;
   -- graph -      ,
   -- root -  ,    
   ----------------------------------------------------------------
   breadthFirst graph root = brfi graph [root] (neighb2 root graph)
   ----------------------------------------------------------------
   -- visited -    ;
   -- queue -  ,  
   ----------------------------------------------
   brfi graph visited queue 
                 | null queue = reverse visited
                 | elem (head queue) visited 
                              = brfi graph visited (tail queue) 
                 | True       = brfi graph
                                     ((head queue):visited)
                                     (queue ++ neighb2 (head queue)
                                                       graph)
   ----------------------------------------------------------
   --   :
   ---------------------------------------------------------
   test =   breadthFirst [(1,[2,3,4]),(2,[1,3]),(3,[1,2,4]),
                          (4,[1,3,5]),(5,[4])] 4 == [4,1,3,5,2]
         && breadthFirst [(1,[2,3,4]),(2,[3]),(3,[4])] 1 
                                                 == [1,2,3,4]
         && breadthFirst [(1,[2,3,4]),(2,[3]),(3,[4])] 2 
                                                 == [2,3,4]
         && breadthFirst [(1,[2,3,4]),(2,[3]),(3,[4])] 3 
                                                 == [3,4]
         && breadthFirst [(1,[2,3,4]),(2,[3,1]),(3,[4])] 2 
                                                 == [2,3,1,4]
   ----------------------------------------------------------
   -- "    ..."
   -------------------------------------------------------
         && breadthFirst [(1,[2,3]),(2,[4,5]),(3,[6,7])] 1 
                                     == [1,2,3,4,5,6,7]
         && breadthFirst [(10,[5,15]),(5,[3,7]),(7,[6,8]),
                          (15,[12,16]),(3,[]),(6,[]),(8,[]),
                          (12,[]),(16,[])] 10 
                                     == [10,5,15,3,7,12,16,6,8]
   ------------------------------------------------------------
   -- "''    ..."
   -------------------------------------------------------
         && breadthFirst [(10,[5,15]),(5,[3,7]),(7,[6,8]),
                          (15,[12,16])] 15 == [15,12,16]